# AUTOGENERATED! DO NOT EDIT! File to edit: 50_time.ipynb (unless otherwise specified).

__all__ = ['TimeKeeper']

# Cell
import json
from typing import Union

import pandas as pd

# Cell

class TimeKeeper:

    def __init__(self) -> None:

        self.df = pd.DataFrame(columns=['time'])
        self.df.index.name = 'category'

    def process_category_name(self, category_name: Union[str, list]) -> str:

        if type(category_name)==str:

            try:

                category_name = json.loads(category_name)

                if type(category_name)==str:

                    return category_name

            except json.JSONDecodeError:

                return category_name

        return category_name[-1].split('/')[-1]

    def record(self, minutes: int, category_name: Union[str, list]) -> None:

        self.df.loc[self.process_category_name(category_name)] = minutes

    def __str__(self) -> str:

        return f'Accumulated time: {self.df["time"].sum()} minutes'

    def plot(self):

#         ax = self.df.plot.pie(y='time', legend=True)
        ax = self.df.plot.pie(y='time')
#         ax.legend(bbox_to_anchor=(1.2, 0.5))
        ax.legend().remove()
        ax.set_ylabel(None)

        return ax